VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Discos"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Obtiene el nmero de serie de las unidades de una pc."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum DRIVE
    'Valores de retorno de GetDriveType
    REMOVABLE = 2
    FIXED = 3
    REMOTE = 4
    'Estos tipos no estn en el fichero de las declaraciones del API de 16 bits
    CDROM = 5
    RAMDISK = 6
End Enum


'Funciones de la API de Windows
'Esta funcin determina el tipo de unidad de la que se hace referencia.
Private Declare Function GetDriveType Lib "Kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
'Esta funcin devuelve algunas caractersticas de una unidad cualquiera.
Private Declare Function GetVolumeInformation Lib "Kernel32" Alias "GetVolumeInformationA" _
    (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, _
    ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, _
    lpMaximumComponentLength As Long, lpFileSystemFlags As Long, _
    ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long


'La funcin busca y devuelve la letra de una unidad cualquiera (rgido, cdrom, flopy, etc).
Private Function Unidad(Optional ByVal intUnidad As DRIVE = FIXED) As String
    Dim x As Byte, lDrive As Long, szRoot As String
    'Desde la A a la Z busca la ubicacin de la unidad.
    For x = 65 To 90
        szRoot = Chr(x) & ":\"              'Crea la direccin de la unidad (ej: c:\)
        lDrive = GetDriveType(szRoot)       'Busca en la API a que unidad pertence.
        If lDrive = intUnidad Then          'Compara si es la unidad buscada.
            Exit For
        End If
    Next
    'Devuelve la letra de la unidad que se buscaba.
    Unidad = szRoot
End Function


'Esta funcin devuelve el valor del nmero de serie de una unidad x, "X:\".
Private Function DiscoSerie(ByVal strDisco As String) As String
    Dim Serie As Long, n As Long, s1 As String, s2 As String, Temp
    s1 = String$(255, Chr$(0))
    s2 = String$(255, Chr$(0))
    'La funcin Get devuelve a cada variable el valor correspondiente.
    'La variable importante es Serie, que determina el nmero de serie de la unidad.
    Temp = GetVolumeInformation(strDisco, s1, Len(s1), Serie, 0, 0, s2, Len(s2))
    DiscoSerie = Serie
End Function


Public Function serial(Optional ByVal intUnidad As DRIVE = FIXED) As String
    serial = DiscoSerie(Unidad(intUnidad))
End Function

